/*
  TODO:
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <Path.h>
#include <Entry.h>
#include <Alert.h>
#include <Resources.h>
#include <String.h>
#include <Roster.h>

#include "App.h"
#include "EditorBuffer.h"
#include "EditorView.h"
#include "ThreadMagic.h"

using namespace threadmagic;

//
//  Globals
//
const char			*gSignature		= "application/x-vnd.101-"PROGRAMNAME;
const char			*gAppsign		= "x-vnd.101-"PROGRAMNAME;

#define VSTUB "0.0.0"

#ifdef	__INTEL__
 #define VERSION	VSTUB" x86"
#else
 #define VERSION	VSTUB" ppc"
#endif

//
//  App
//
App :: App() : BApplication(gSignature), fBuffer(0) {
	
	// Change to the dir where the app executable is.
	team_info ti;
	app_info ai;
	be_roster -> GetRunningAppInfo(ti.team, &ai);
	BPath path;
	BEntry appentry(&ai.ref), parent;
	appentry.GetParent(&parent);
	parent.GetPath(&path);
	chdir(path.Path());
}

App :: ~App() {
}

bool App :: QuitRequested() {
	CleanUp();
	return true;
}

void App :: CleanUp() {
}

//void App :: MessageReceived(BMessage *inMsg) {
//	switch (inMsg -> what) {
//		default:
//			inherited :: MessageReceived(inMsg);
//	}
//}

//void SyXApp :: ArgvReceived(int32 argc, char **argv) {
//}

void App :: ReadyToRun() {
	// Create a buffer
	fBuffer = new EditorBuffer();
	BWindow *w = new BWindow(BRect(20, 20, 260, 220), "dodo", B_DOCUMENT_WINDOW, 0);
	w -> Lock();
	// Create a view (and attach to the buffer)
	// And attach the view to the window
	w -> AddChild(new EditorView(fBuffer, BRect(0, 0, 200, 100), "View A"));
	w -> AddChild(new EditorView(fBuffer, BRect(0, 101, 200, 200), "View B"));
	w -> Unlock();
	w -> Show();

	// This one starts a thread that will call the function in every second.
	// (make some changes on the buffer, we start two of them)
	PeriodicThread :: Launch(NewFunctionObject( this, & App :: SomeThreadFunc, BString("Thread 1") ),
							  1000000
							 );
	
	snooze(500000);	// Wait half a second
	
	PeriodicThread :: Launch(new FunctionObjectTemplate<typeof( & App :: SomeThreadFunc )>
												( this, &App :: SomeThreadFunc, BString("Thread 2") ),
							  1000000
							 );
}

// Some threading, too... Here we pass a reference to the thread param (which is a string)
// further to ChangeData()

bool App :: SomeThreadFunc(BString &inStr) {
	if (CountWindows() == 0) {
		PostMessage(B_QUIT_REQUESTED);
		return false;				// != B_OK means exit_thread()
	}
	fBuffer -> ChangeData(inStr);	// Pass the param inStr further
	return true;
}

//thread_id App :: Run() {
//	return BApplication :: Run();
//}

extern "C" void SetNewLeakChecking(bool);
extern "C" void SetMallocLeakChecking(bool);

//
//  Main
//
int main(void)  {
//	SetNewLeakChecking(true);		// *!*!*!*
//	SetMallocLeakChecking(true);	// *!*!*!*
	
	be_app = new App();
	

	be_app -> Run();
	delete be_app;
	
	return B_OK;
}



