
#ifndef EDITORBUFFER_H
#define EDITORBUFFER_H

#include <Entry.h>
#include <Autolock.h>

#include "Globals.h"
#include "ThreadMagic.h"

#include <hash_map>
#include <list>

class EditorBuffer {
	
	typedef vector<EditorView *>		view_vector_t;
	
	int32						fData;
	view_vector_t				fViews;
	BLocker						fLocker;
	
public:
						EditorBuffer();
						~EditorBuffer();

	int32				Data();

	void					ConnectView(EditorView *);
	bool					DisconnectView(EditorView *);
	void					NotifyViews(threadmagic::FunctionObject *);
	void					ChangeData(BString &);
	
	bool					Lock()			{ return fLocker.Lock(); }
	void					Unlock()		{ fLocker.Unlock(); }
	BLocker 			*Locker()		{ return &fLocker; }
	void					LockCheck()		{ if ( ! fLocker.IsLocked()) debugger("EditorBuffer must be locked !!!"); }
};


#endif // EDITORBUFFER_H
