
#include <Debug.h>

#include <String.h>

#include <iostream>

#include "ThreadMagic.h"

using namespace std;
using namespace threadmagic;

void vfoo4(int, float, double, char )				{ }
void vfoo3(int, float, double)						{ }
void vfoo2(int, float)						 	{ }
void vfoo1(int)										{ }
void vfoo0()										{ }

status_t foo4(int, float, double, char )				{ return 0; }
status_t foo3(int, float, double)						{ return 0; }
status_t foo2(int, float)								{ return 0; }
status_t foo1(int)										{ return 0; }
status_t foo0()											{ return 0; }
																			
class Test {
public:
	int	i;
	int j;

	Test() { i = 0; }
	Test(const Test &other) {
		cout << "copy ctor" << endl;
		i = other.i;
	}

	void vfoo4(int, float, double, char )				{ }
	void vfoo3(int, float, double)						{ }
	void vfoo2(int, float)							{ }
	void vfoo1(int)										{ }
	void vfoo0()										{ }

	status_t foo4(int, float, double, char )				{ return 0; }
	status_t foo3(int, float, double)						{ return 0; }
	status_t foo2(int, float)								{ return 0; }
	status_t foo1(int)										{ return 0; }
	status_t foo0()											{ return 0; }
																				
	status_t cfoo4(int, float, double, char)		const		{ return 0; }
	status_t cfoo3(int, float, double)				const		{ return 0; }
	status_t cfoo2(int, float)						const		{ return 0; }
	status_t cfoo1(int)								const		{ return 0; }
	status_t cfoo0()								const		{ return 0; }

	void vcfoo4(int, float, double, char)		const		{ }
	void vcfoo3(int, float, double)				const		{ }
	void vcfoo2(int, float)						const		{ }
	void vcfoo1(int)								const		{ }
	void vcfoo0()								const		{ }

//	This way there'll be three copy ctor call, that's definately bad
	void printer_val(const Test test) {
		cout << test.i << endl;
	}
//	This way there'll be one ctor call to copy the data. usefull for threads
	void printer_ref(const Test &test) {
		cout << test.i << endl;
	}
//	This way there'll be no ctor call (pointer will be copied). take care with threading!
	void printer_ptr(const Test *test) {
		cout << test->i << endl;
	}
	
	void BString_printer_val(BString str) {
		cout << str.String() << endl;
	}
	void BString_printer_ref(BString &str) {
		cout << str.String() << endl;
	}
	void BString_printer_ptr(BString *str) {
		cout << str -> String() << endl;
	}
};																			

int main() {
//XXX

	Test test;

	FunctionObject *x;		// test base class with assignment
	
	cout << endl << "### Passing a pointer:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::printer_ptr)>(&test, &Test::printer_ptr, &test);
	(*x)();
	test.i = 12345678;
	(*x)();
	test.i = 0;

	cout << endl << "### Passing a reference:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::printer_ref)>(&test, &Test::printer_ref, test);
	(*x)();
	test.i = 12345678;
	(*x)();
	test.i = 0;

	cout << endl << "### Passing by value:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::printer_val)>(&test, &Test::printer_val, test);
	(*x)();
	test.i = 12345678;
	(*x)();
	test.i = 0;


	BString str("test");

	cout << endl << "*** BString printer by ptr:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::BString_printer_ptr)>(&test, &Test::BString_printer_ptr, &str);
	(*x)();
	str = "changed";
	(*x)();
	str = "test";

	cout << endl << "*** BString printer by ref:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::BString_printer_ref)>(&test, &Test::BString_printer_ref, str);
	(*x)();
	str = "changed";
	(*x)();
	str = "test";

	cout << endl << "*** BString printer by val:" << endl;
	x = new FunctionObjectTemplate<typeof(&Test::BString_printer_val)>(&test, &Test::BString_printer_val, str);
	(*x)();
	str = "changed";
	(*x)();
	str = "test";

	x = NewFunctionObject(&test, &Test::foo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::foo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::foo2, 1, 2);
	x = NewFunctionObject(&test, &Test::foo1, 1);
	x = NewFunctionObject(&test, &Test::foo0);
	
	// void return
	x = NewFunctionObject(&test, &Test::vfoo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::vfoo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::vfoo2, 1, 2);
	x = NewFunctionObject(&test, &Test::vfoo1, 1);
	x = NewFunctionObject(&test, &Test::vfoo0);

	// this
	x = NewFunctionObject(&test, &Test::foo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::foo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::foo2, 1, 2);
	x = NewFunctionObject(&test, &Test::foo1, 1);
	x = NewFunctionObject(&test, &Test::foo0);
	
	// const
	x = NewFunctionObject(&test, &Test::cfoo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::cfoo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::cfoo2, 1, 2);
	x = NewFunctionObject(&test, &Test::cfoo1, 1);
	x = NewFunctionObject(&test, &Test::cfoo0);
	
	// const, this
	x = NewFunctionObject(&test, &Test::cfoo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::cfoo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::cfoo2, 1, 2);
	x = NewFunctionObject(&test, &Test::cfoo1, 1);
	x = NewFunctionObject(&test, &Test::cfoo0);

	// void return, const
	x = NewFunctionObject(&test, &Test::vcfoo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&test, &Test::vcfoo3, 1, 2, 3);
	x = NewFunctionObject(&test, &Test::vcfoo2, 1, 2);
	x = NewFunctionObject(&test, &Test::vcfoo1, 1);
	x = NewFunctionObject(&test, &Test::vcfoo0);

// Plain C functions

	// 
	x = NewFunctionObject(&foo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&foo3, 1, 2, 3);
	x = NewFunctionObject(&foo2, 1, 2);
	x = NewFunctionObject(&foo1, 1);
	x = NewFunctionObject(&foo0);
	
	// void return
	x = NewFunctionObject(&vfoo4, 1, 2, 3, 'c');
	x = NewFunctionObject(&vfoo3, 1, 2, 3);
	x = NewFunctionObject(&vfoo2, 1, 2);
	x = NewFunctionObject(&vfoo1, 1);
	x = NewFunctionObject(&vfoo0);

// direct templates

	// 
	x = new FunctionObjectTemplate<typeof(&Test :: foo4)>(&Test::foo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: foo3)>(&Test::foo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: foo2)>(&Test::foo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: foo1)>(&Test::foo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: foo0)>(&Test::foo0);
	
	// void return
	x = new FunctionObjectTemplate<typeof(&Test :: vfoo4)>(&Test::vfoo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: vfoo3)>(&Test::vfoo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: vfoo2)>(&Test::vfoo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: vfoo1)>(&Test::vfoo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: vfoo0)>(&Test::vfoo0);

	// this
	x = new FunctionObjectTemplate<typeof(&Test :: foo4)>(&test, &Test::foo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: foo3)>(&test, &Test::foo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: foo2)>(&test, &Test::foo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: foo1)>(&test, &Test::foo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: foo0)>(&test, &Test::foo0);
	
	// const
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo4)>(&Test::cfoo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo3)>(&Test::cfoo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo2)>(&Test::cfoo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo1)>(&Test::cfoo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo0)>(&Test::cfoo0);
	
	// const, this
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo4)>(&test, &Test::cfoo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo3)>(&test, &Test::cfoo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo2)>(&test, &Test::cfoo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo1)>(&test, &Test::cfoo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: cfoo0)>(&test, &Test::cfoo0);

	// void return, const
	x = new FunctionObjectTemplate<typeof(&Test :: vcfoo4)>(&Test::vcfoo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&Test :: vcfoo3)>(&Test::vcfoo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&Test :: vcfoo2)>(&Test::vcfoo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&Test :: vcfoo1)>(&Test::vcfoo1, 1);
	x = new FunctionObjectTemplate<typeof(&Test :: vcfoo0)>(&Test::vcfoo0);

// Plain C functions

	// 
	x = new FunctionObjectTemplate<typeof(&foo4)>(&foo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&foo3)>(&foo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&foo2)>(&foo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&foo1)>(&foo1, 1);
	x = new FunctionObjectTemplate<typeof(&foo0)>(&foo0);
	
	// void return
	x = new FunctionObjectTemplate<typeof(&vfoo4)>(&vfoo4, 1, 2, 3, 'c');
	x = new FunctionObjectTemplate<typeof(&vfoo3)>(&vfoo3, 1, 2, 3);
	x = new FunctionObjectTemplate<typeof(&vfoo2)>(&vfoo2, 1, 2);
	x = new FunctionObjectTemplate<typeof(&vfoo1)>(&vfoo1, 1);
	x = new FunctionObjectTemplate<typeof(&vfoo0)>(&vfoo0);
}
