/*
  TODO:
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <Path.h>
#include <Button.h>
#include <Alert.h>
#include <Resources.h>
#include <String.h>
#include <Roster.h>

#include "App.h"
#include "ThreadMagic.h"

using namespace threadmagic;

//
//  Globals
//
const char			*gSignature		= "application/x-vnd.101-"PROGRAMNAME;
const char			*gAppsign		= "x-vnd.101-"PROGRAMNAME;
Preferences			*gCommonPrefs	= NULL;
Preferences			*gUserPrefs		= NULL;

#define VSTUB "0.0.0"

#ifdef	__INTEL__
 #define VERSION	VSTUB" x86"
#else
 #define VERSION	VSTUB" ppc"
#endif

//
//  App
//
App :: App() : BApplication(gSignature), mPool(2, 5) {
	
	// Change to the dir where the app executable is.
	team_info ti;
	app_info ai;
	be_roster -> GetRunningAppInfo(ti.team, &ai);
	BPath path;
	BEntry appentry(&ai.ref), parent;
	appentry.GetParent(&parent);
	parent.GetPath(&path);
	chdir(path.Path());
}

App :: ~App() {
}

bool App :: QuitRequested() {
	CleanUp();
	return true;
}

void App :: CleanUp() {
}

void App :: Pulse() {
	char buf[512];
	sprintf(buf, "Max threads: %ld, min threads: %ld, current threads: %ld, idle: %ld\nEnqueued tasks: %ld\n",
				(int32)mPool.MaxThreads(), (int32)mPool.MinThreads(), (int32)mPool.CurrentThreads(),
				(int32)mPool.IdleThreads(), (int32)mPool.EnqueuedTasks());
	if (mTextView -> LockLooper()) {
		mTextView -> SetText(buf);
		mTextView -> UnlockLooper();
	} else {
		be_app -> PostMessage(B_QUIT_REQUESTED);
	}
}


void App :: MessageReceived(BMessage *inMsg) {

//inMsg -> PrintToStream();

	switch (inMsg -> what) {
		case 'bt01':
			mPool.Do(NewFunctionObject(this, &App::Task1, 3));
			break;
		case 'bt02':
			mPool.Do(NewFunctionObject(this, &App::Task2, 5));
			break;
		case 'updt': {
			char buf[512];
			sprintf(buf, "Max threads: %ld, min threads: %ld, current threads: %ld, idle: %ld\nEnqueued tasks: %ld\n",
						(int32)mPool.MaxThreads(), (int32)mPool.MinThreads(), (int32)mPool.CurrentThreads(),
						(int32)mPool.IdleThreads(), (int32)mPool.EnqueuedTasks());
			if (mTextView -> LockLooper()) {
				mTextView -> SetText(buf);
				mTextView -> UnlockLooper();
			} else {
				be_app -> PostMessage(B_QUIT_REQUESTED);
			}
			break;
		}
		default:
			inherited :: MessageReceived(inMsg);
	}
}

//void SyXApp :: ArgvReceived(int32 argc, char **argv) {
//}

void App :: ReadyToRun() {
	SetPulseRate(1000000);

	BWindow *w = new BWindow(BRect(20, 20, 330, 220), "dodo", B_TITLED_WINDOW, 0);
	w -> Lock();
	BButton *button = new BButton(BRect(10, 10, 80, 20), "", "Push me", new BMessage('bt01'));
	w -> AddChild(button);
	button -> SetTarget(be_app_messenger);
	button = new BButton(BRect(10, 30, 80, 40), "", "Push me", new BMessage('bt02'));
	w -> AddChild(button);
	button -> SetTarget(be_app_messenger);
	mTextView = new BTextView(BRect(10, 60, 300, 180), "", BRect(10, 60, 300, 180), B_FOLLOW_ALL, B_FRAME_EVENTS | B_WILL_DRAW | B_PULSE_NEEDED);
	w -> AddChild(mTextView);
	mTextView -> SetViewColor(200, 200, 200);
	mTextView -> SetHighColor(0, 0, 0);
	mTextView -> SetWordWrap(true);
	mTextView -> MakeSelectable(true);
	mTextView -> MakeEditable(false);
	mTextView -> SetText("Run me from terminal to see the oiutput of the threads!");

	w -> Unlock();
	w -> Show();
}

// Some threading, too... Here we pass a reference to the thread param
// further to ChangeData()

status_t App :: Task1(int &iDelay) {
	cout << "thread " << find_thread(0) << " waiting " << iDelay << " secs in Task1()\n";
	snooze(iDelay * 1000000);
	be_app -> PostMessage('updt');
	return B_OK;
}

status_t App :: Task2(int &iDelay) {
	cout << "thread " << find_thread(0) << " waiting " << iDelay << " secs in Task2()\n";
	snooze(iDelay * 1000000);
	be_app -> PostMessage('updt');
	return B_OK;
}

//thread_id App :: Run() {
//	return BApplication :: Run();
//}

extern "C" void SetNewLeakChecking(bool);
extern "C" void SetMallocLeakChecking(bool);

//
//  Main
//
int main(void)  {
//	SetNewLeakChecking(true);		// *!*!*!*
//	SetMallocLeakChecking(true);	// *!*!*!*
	
	be_app = new App();
	
//	gCommonPrefs = new Preferences(gSignature, true);
//	gUserPrefs = new Preferences(gSignature, false);
//	const char *str;
//	if (gUserPrefs -> FindString("Version", &str) == B_OK  &&  strcmp(str, VSTUB)) {
//		BAlert *alert = new BAlert(PROGRAMNAME, PROGRAMNAME
//							":\n\nThe version of the saved preferences is older then the executable ! "
//							"You may try to load it or use the defaults (but then the old settings will be overwritten at exit !)\n"
//							"(Loading the old prefs should not cause any harm, but if you get empty charts or similar I recommend loading the defaults !)\n"
//							"FOR VERSION 0.3.0: Use the defaults, the prefs format changed !!! Or read the readme for info on how to migrate your settings...",
//							"Quit", "Use defaults", "Load", B_WIDTH_FROM_LABEL, B_OFFSET_SPACING, B_STOP_ALERT);
//		switch (alert -> Go()) {
//			case 0:
//				//delete be_app;
//				exit(0);
//				break;
//			case 1:
//				gUserPrefs -> MakeEmpty();
//				break;
//		}
//	}
//	
//	if (gUserPrefs -> IsEmpty()) {
//		BResources *app_res = be_app -> AppResources();
//		size_t len;
//		const void *data;
//		if ((data = app_res -> LoadResource(B_ANY_TYPE, "Defaults", &len)) != NULL) {
//			gUserPrefs -> Unflatten((char *)data);
//		}
//	}

	be_app -> Run();
	delete be_app;
	
//	gUserPrefs -> SetString("Version", VSTUB);
	
//	gCommonPrefs -> Sync();
//	delete gCommonPrefs;
//	gUserPrefs -> Sync();
//	delete gUserPrefs;
	
	return B_OK;
}



