//
//  Preferences.h	Copyright (C) 1998 by Attila Lendvai
//	Freeware, use as you want, no warranies.

#if !defined(PREFERENCES_H)
#define PREFERENCES_H

#include <SupportDefs.h>
#include <Message.h>
#include <Entry.h>

class Preferences;

extern Preferences *gCommonPrefs;
extern Preferences *gUserPrefs;

//
//	The class itself
//
class Preferences : public BMessage {
	entry_ref			fEntryRef;
	status_t			fStatus;
	bool				fCommon;

	void				initialise(const char *, bool);

public:
						Preferences(const char *, bool inCommon= false);
//						~Preferences();
//			status_t	AddListener(BMessenger *);
//			status_t	RemoveListener(BMessenger *);
			status_t	LoadFrom(BFile *);
			status_t	SaveTo(BFile *);
			status_t	Sync(void);
			status_t	Revert(void);
	inline	status_t	InitCheck() { return fStatus; }
	inline	bool		IsEmpty() 	{ return (CountNames(B_ANY_TYPE) == 0); }

			status_t	SetData		(const char *, type_code, const void *, ssize_t);
			status_t	SetPoint	(const char *, BPoint);
			status_t	SetRect		(const char *, BRect);
			status_t	SetString	(const char *, const char *);
			status_t	SetInt64	(const char *, int64);
			status_t	SetInt32	(const char *, int32);
			status_t	SetInt16	(const char *, int16);
			status_t	SetInt8		(const char *, int8);
			status_t	SetFloat	(const char *, float);
			status_t	SetBool		(const char *, bool);
			status_t	SetMessage	(const char *, BMessage *);
};

#endif //PREFERENCES_H
