
#if !defined(DragView_h)
#define DragView_h

#include <View.h>
#include <TranslationDefs.h>

#include "ThreadMagic.h"

class BBitmap;
class BMenuField;

class DragView : public BView {

	friend class DragWindow;
public:
		DragView(
				const BRect & area);
virtual	~DragView();

		bool				PeriodicThreadFunc(BString &, BPoint &);
		status_t		ThreadFunc(int &, const char *&);
		status_t		CooperativeThreadFunc();
		bool				MouseTrackingFunc(BPoint &inPoint, uint32 inButtons);

virtual	void Draw(BRect area);
virtual	void MouseDown(BPoint where);
virtual void AllAttached();

		enum {
			SET_DRAG_MODE = 'dv00'
		};
private:

		threadmagic::PeriodicThread *	fPeriodicThread;
		threadmagic::Thread *			fThread;
		threadmagic::Thread *			fCooperativeThread;
		BRect							fDragRect;


		BBitmap * m_bitmap;				//	bitmap to drag
		BView * m_bitmapView;			//	for drawing into bitmap
		drawing_mode m_mode;			//	used for dragging
		translator_id m_translator;		//	the translator to use
		uint32 m_type_code;				//	the type to translate to
		char m_the_type[256];			//	the MIME type of that type
};

#endif	//	DragView_h
